**LeetCode Problem | LeetCode Problems For Beginners | LeetCode Problems & Solutions | Improve Problem Solving Skills | LeetCode Problems Java | LeetCode Solutions in C++**

Hello **Programmers/Coders,** Today we are going to share ** solutions to the Programming problems of LeetCode Solutions in C++, Java, & Python**. At Each Problem with Successful submission with

**all Test Cases Passed,**you will get a score or marks and LeetCode Coins. And after solving maximum problems, you will be getting stars. This will highlight your profile to the recruiters.

In this post, you will find the solution for the **Gas Station** **in C++, Java & Python-LeetCode problem**. We are providing the **correct and tested solutions** to coding problems present on **LeetCode**. If you are not able to solve any problem, then you can take help from our Blog/website.

Use “Ctrl+F” To Find Any Questions Answer. & For Mobile User, You Just Need To Click On Three dots In Your Browser & You Will Get A “Find” Option There. Use These Option to Get Any Random Questions Answer.

**About LeetCode**

*LeetCode* is one of the most well-known online judge platforms to help you enhance your skills, expand your knowledge and prepare for technical interviews.

LeetCode is for **software engineers who are looking to practice technical questions and advance their skills**. Mastering the questions in each level on LeetCode is a good way to prepare for technical interviews and keep your skills sharp. They also have a repository of solutions with the reasoning behind each step.

LeetCode has over 1,900 questions for you to practice, covering many different programming concepts. Every coding problem has a classification of either *Easy*, *Medium*, or *Hard*.

**LeetCode problems focus on algorithms and data structures. Here is some topic you can find problems on LeetCode:**

- Mathematics/Basic Logical Based Questions
- Arrays
- Strings
- Hash Table
- Dynamic Programming
- Stack & Queue
- Trees & Graphs
- Greedy Algorithms
- Breadth-First Search
- Depth-First Search
- Sorting & Searching
- BST (Binary Search Tree)
- Database
- Linked List
- Recursion, etc.

Leetcode has a huge number of test cases and questions from interviews too like Google, Amazon, Microsoft, Facebook, Adobe, Oracle, Linkedin, Goldman Sachs, etc. LeetCode helps you in getting a job in Top MNCs. To crack FAANG Companies, LeetCode problems can help you in building your logic.

** Link for the Problem** – Gas Station– LeetCode Problem

Gas Station– LeetCode Problem

**Problem:**

There are `n`

gas stations along a circular route, where the amount of gas at the `i`

station is ^{th}`gas[i]`

.

You have a car with an unlimited gas tank and it costs `cost[i]`

of gas to travel from the `i`

station to its next ^{th}`(i + 1)`

station. You begin the journey with an empty tank at one of the gas stations.^{th}

Given two integer arrays `gas`

and `cost`

, return *the starting gas station’s index if you can travel around the circuit once in the clockwise direction, otherwise return* `-1`

. If there exists a solution, it is **guaranteed** to be **unique**

**Example 1:**

Input:gas = [1,2,3,4,5], cost = [3,4,5,1,2]Output:3Explanation:Start at station 3 (index 3) and fill up with 4 unit of gas. Your tank = 0 + 4 = 4 Travel to station 4. Your tank = 4 - 1 + 5 = 8 Travel to station 0. Your tank = 8 - 2 + 1 = 7 Travel to station 1. Your tank = 7 - 3 + 2 = 6 Travel to station 2. Your tank = 6 - 4 + 3 = 5 Travel to station 3. The cost is 5. Your gas is just enough to travel back to station 3. Therefore, return 3 as the starting index.

**Example 2:**

Input:gas = [2,3,4], cost = [3,4,3]Output:-1Explanation:You can't start at station 0 or 1, as there is not enough gas to travel to the next station. Let's start at station 2 and fill up with 4 unit of gas. Your tank = 0 + 4 = 4 Travel to station 0. Your tank = 4 - 3 + 2 = 3 Travel to station 1. Your tank = 3 - 3 + 3 = 3 You cannot travel back to station 2, as it requires 4 unit of gas but you only have 3. Therefore, you can't travel around the circuit once no matter where you start.

**Constraints:**

`gas.length == n`

`cost.length == n`

`1 <= n <= 10`

^{5}`0 <= gas[i], cost[i] <= 10`

^{4}

Gas Station– LeetCode Solutions

Gas Station Solution in C++:

class Solution { public: int canCompleteCircuit(vector<int>& gas, vector<int>& cost) { const int gasses = accumulate(begin(gas), end(gas), 0); const int costs = accumulate(begin(cost), end(cost), 0); if (gasses - costs < 0) return -1; int ans = 0; int sum = 0; // try to start from each index for (int i = 0; i < gas.size(); ++i) { sum += gas[i] - cost[i]; if (sum < 0) { sum = 0; ans = i + 1; // start from next index } } return ans; } };

Gas Station Solution in Java:

class Solution { public int canCompleteCircuit(int[] gas, int[] cost) { final int gasses = Arrays.stream(gas).sum(); final int costs = Arrays.stream(cost).sum(); if (gasses - costs < 0) return -1; int ans = 0; int sum = 0; // try to start from each index for (int i = 0; i < gas.length; ++i) { sum += gas[i] - cost[i]; if (sum < 0) { sum = 0; ans = i + 1; // start from next index } } return ans; } }

Gas Station Solution in Python:

class Solution: def canCompleteCircuit(self, gas: List[int], cost: List[int]) -> int: ans = 0 net = 0 sum = 0 for i in range(len(gas)): net += gas[i] - cost[i] sum += gas[i] - cost[i] if sum < 0: sum = 0 ans = i + 1 return -1 if net < 0 else ans